CREATE PROCEDURE usp_BCP_Table_Out @tablename varchar(30),
                                   @outpath varchar(255)
AS

/*
**       
**  SQL DMO    .
*/

/*    */
DECLARE @oSQL INT, @oBCP INT  /*      */
DECLARE @status INT     /*      */
DECLARE @source VARCHAR(255), @description VARCHAR(255)

/*  ,       */
DECLARE @iNumRows INT    /*    */

/*      SOL-DMO */
DECLARE @temp VARCHAR(255) 
DECLARE @db_name VARCHAR(30)  /*    */
/*
**   SQL Server 
*/
EXEC @status = sp_OACreate 'SQLDMO.SQLServer', @oSQL OUT

IF @status <> 0
BEGIN
	EXEC @status = sp_OAGetErrorInfo @oSQL, @source, @description
	SELECT @source " ", @description " "
	RETURN
END

/*
**   SQL Server
*/
EXEC @status = sp_OAMethod @oSQL, "Connect", NULL, "(local)", "sa"

IF @status <> 0
BEGIN
	EXEC @status = sp_OAGetErrorInfo @oSQL, @source, @description
	SELECT  @source " ", @description " "
	RETURN
END

/*
**   BCP 
*/
EXEC @status = sp_OACreate 'SQLDMO.BulkCopy', @oBCP OUT

IF @status <> 0
BEGIN
	EXEC @status = sp_OAGetErrorInfo @oBCP, @source, @description
	SELECT  @source " ", @description " "
	RETURN
END

/*
**     BCP 
*/

/*
**        
*/
EXEC @status = sp_OASetProperty @oBCP, 'DataFilePath', @outpath
IF @status <> 0
BEGIN
	EXEC @status = sp_OAGetErrorInfo @oBCP, @source, @description
	SELECT  @source " ", @description " "
	RETURN
END

/*
**       
*/
EXEC @status = sp_OASetProperty @oBCP, 'ErrorFilePath', "C:\bcperror.txt"

IF @status <> 0
BEGIN
	EXEC @status = sp_OAGetErrorInfo @oBCP, @source, @description
	SELECT  @source " ", @description " "
	RETURN
END

EXEC @status = sp_OASetProperty @oBCP, 'LogFilePath', "C:\bcplog.txt"

IF @status <> 0
BEGIN
	EXEC @status = sp_OAGetErrorInfo @oBCP, @source, @description
	SELECT @source " ", @description " "
	RETURN
END

/*
**         .
**     ExportData    
**  SQL Server,      .
**
** :       
**  DB_Name     .
*/
Select @db_name = DB_NAME()

/*
**   SQL_DMO
*/
Select @temp =  'Databases(' + '"' + @db_name + '"' + ').Tables('
Select @temp = @temp + '"' + @tablename + '"' + ').ExportData'

/*
**   ,    SQL Server
*/
EXEC @status = sp_OAMethod @oSQL, @temp, @iNumRows OUT, @oBCP

IF @status <> 0
BEGIN
	EXEC @status = sp_OAGetErrorInfo @oSQL, @source, @description
	SELECT  @source " ", @description " "
	RETURN
END

Select @iNumRows "  "

/*
**     OLE 
*/
EXEC @status = sp_OADestroy @oBCP
IF @status <> 0
BEGIN
	EXEC @status = sp_OAGetErrorInfo @oBCP, @source, @description
	SELECT  @source " ", @description " "
END

EXEC @status = sp_OADestroy @oSQL
IF @status <> 0
BEGIN
	EXEC @status = sp_OAGetErrorInfo  @oSQL, @source, @description
	SELECT  @source " ", @description " "
END
